chiark / gitweb /
Fix manpage description of --existing-package.
[dgit.git] / dgit
diff --git a/dgit b/dgit
index 0fb928906f06833c553a8d7fc2c9b47d64f484cc..ab3d593ec0e751a4deb08406042cc816d39af21b 100755 (executable)
--- a/dgit
+++ b/dgit
@@ -24,20 +24,17 @@ use Data::Dumper;
 use LWP::UserAgent;
 use Dpkg::Control::Hash;
 use File::Path;
+use Dpkg::Version;
 use POSIX;
 
-our $mirror = 'http://mirror.relativity.greenend.org.uk/mirror/debian-ftp/';
-our $suite = 'sid';
+our $isuite = 'unstable';
 our $package;
 
 our $sign = 1;
 our $dryrun = 0;
 our $changesfile;
-
-our $aliothname = 'iwj@git.debian.org';
-our $aliothpath = '/git/dgit-repos';
-our $alioth_git = "git+ssh://$aliothname/$aliothpath";
-our $alioth_sshtestbodge = [$aliothname,$aliothpath];
+our $new_package = 0;
+our $existing_package = 'dpkg';
 
 our %format_ok = map { $_=>1 } ("1.0","3.0 (native)","3.0 (quilt)");
 
@@ -47,6 +44,7 @@ our (@dput) = qw(dput);
 our (@debsign) = qw(debsign);
 our $keyid;
 
+our $debug = 0;
 open DEBUG, ">/dev/null" or die $!;
 
 our %opts_opt_map = ('dget' => \@dget,
@@ -54,18 +52,19 @@ our %opts_opt_map = ('dget' => \@dget,
                     'debsign' => \@debsign);
 
 our $remotename = 'dgit';
-our $ourdscfield = 'Vcs-Git-Master';
+our $ourdscfield = 'Vcs-Dgit-Master';
 our $branchprefix = 'dgit';
+our $csuite;
 
-sub lbranch () { return "$branchprefix/$suite"; }
+sub lbranch () { return "$branchprefix/$csuite"; }
 my $lbranch_re = '^refs/heads/'.$branchprefix.'/([^/.]+)$';
 sub lref () { return "refs/heads/".lbranch(); }
-sub lrref () { return "refs/remotes/$remotename/$suite"; }
-sub rrref () { return "refs/$branchprefix/$suite"; }
+sub lrref () { return "refs/remotes/$remotename/$csuite"; }
+sub rrref () { return "refs/$branchprefix/$csuite"; }
 sub debiantag ($) { return "debian/$_[0]"; }
 
 sub fetchspec () {
-    local $suite = '*';
+    local $csuite = '*';
     return  "+".rrref().":".lrref();
 }
 
@@ -101,20 +100,31 @@ sub printcmd {
 }
 
 sub runcmd {
-    printcmd(\*DEBUG,"+",@_);
+    printcmd(\*DEBUG,"+",@_) if $debug>0;
     $!=0; $?=0;
     die "@_ $! $?" if system @_;
 }
 
+sub printdone {
+    if (!$dryrun) {
+       print "dgit ok: @_\n";
+    } else {
+       print "would be ok: @_ (but dry run only)\n";
+    }
+}
+
 sub cmdoutput_errok {
-    printcmd(\*DEBUG,"|",@_);
+    die Dumper(\@_)." ?" if grep { !defined } @_;
+    printcmd(\*DEBUG,"|",@_) if $debug>0;
     open P, "-|", @_ or die $!;
     my $d;
     $!=0; $?=0;
     { local $/ = undef; $d = <P>; }
     die if P->error;
-    close P or return undef;
+    if (!close P) { print DEBUG "=>!$?\n" if $debug>0; return undef; }
     chomp $d;
+    $d =~ m/^.*/;
+    print DEBUG "=> \`$&'",(length $' ? '...' : ''),"\n" if $debug>0; #';
     return $d;
 }
 
@@ -136,6 +146,73 @@ sub runcmd_ordryrun {
     }
 }
 
+our %defcfg = ('dgit.default.distro' => 'debian',
+              'dgit.default.username' => '',
+              'dgit.default.archive-query-default-component' => 'main',
+              'dgit.default.ssh' => 'ssh',
+              'dgit-distro.debian.git-host' => 'git.debian.org',
+              'dgit-distro.debian.git-proto' => 'git+ssh://',
+              'dgit-distro.debian.git-path' => '/git/dgit-repos',
+              'dgit-distro.debian.git-check' => 'ssh-cmd',
+              'dgit-distro.debian.git-create' => 'ssh-cmd',
+              'dgit-distro.debian.sshdakls-host' => 'coccia.debian.org',
+              'dgit-distro.debian.sshdakls-dir' =>
+                  '/srv/ftp-master.debian.org/ftp/dists',
+              'dgit-distro.debian.mirror' => 'http://http.debian.net/debian/');
+
+sub cfg {
+    foreach my $c (@_) {
+       my $v;
+       {
+           local ($debug) = $debug-1;
+           $v = cmdoutput_errok(@git, qw(config --), $c);
+       };
+       if ($?==0) {
+           return $v;
+       } elsif ($?!=256) {
+           die "$c $?";
+       }
+       my $dv = $defcfg{$c};
+       return $dv if defined $dv;
+    }
+    return undef;
+}
+
+sub access_distro () {
+    return cfg("dgit-suite.$isuite.distro",
+              "dgit.default.distro");
+}
+
+sub access_cfg (@) {
+    my (@keys) = @_;
+    my $distro = access_distro();
+    my $value = cfg(map { ("dgit-distro.$distro.$_",
+                          "dgit.default.$_") } @keys);
+    return $value;
+}
+
+sub access_someuserhost ($) {
+    my ($some) = @_;
+    my $user = access_cfg("$some-user",'username');
+    my $host = access_cfg("$some-host");
+    return defined($user) && length($user) ? "$user\@$host" : $host;
+}
+
+sub access_gituserhost () {
+    return access_someuserhost('git');
+}
+
+sub access_giturl () {
+    my $url = access_cfg('git-url');
+    if (!defined $url) {
+       $url =
+           access_cfg('git-proto').
+           access_gituserhost().
+           access_cfg('git-path');
+    }
+    return "$url/$package.git";
+}             
+
 sub parsecontrol {
     my $c = Dpkg::Control::Hash->new();
     $c->load(@_) or return undef;
@@ -151,58 +228,137 @@ sub parsechangelog {
     return $c;
 }
 
-our $rmad;
+our %rmad;
 
-sub askmadison () {
-    $rmad ||= cmdoutput qw(rmadison -asource),"-s$suite",$package;
-    $rmad =~ m/^ \s*( [^ \t|]+ )\s* \|
-                 \s*( [^ \t|]+ )\s* \|
+sub archive_query ($) {
+    my ($method) = @_;
+    my $query = access_cfg('archive-query');
+    if (!$query) {
+       my $distro = access_distro();
+       if ($distro eq 'debian') {
+           $query = "sshdakls:".
+               access_someuserhost('sshdakls').':'.
+               access_cfg('sshdakls-dir');
+       } else {
+           $query = "madison:$distro";
+       }
+    }
+    $query =~ s/^(\w+):// or die "$query ?";
+    my $proto = $1;
+    my $data = $'; #';
+    { no strict qw(refs); &{"${method}_${proto}"}($proto,$data); }
+}
+
+sub archive_query_madison ($$) {
+    my ($proto,$data) = @_;
+    die unless $proto eq 'madison';
+    $rmad{$package} ||= cmdoutput
+       qw(rmadison -asource),"-s$isuite","-u$data",$package;
+    my $rmad = $rmad{$package};
+    return madison_parse($rmad);
+}
+
+sub archive_query_sshdakls ($$) {
+    my ($proto,$data) = @_;
+    $data =~ s/:.*// or die "$data ?";
+    my $dakls = cmdoutput
+       access_cfg('ssh'), $data, qw(dak ls -asource),"-s$isuite",$package;
+    return madison_parse($dakls);
+}
+
+sub canonicalise_suite_sshdakls ($$) {
+    my ($proto,$data) = @_;
+    $data =~ m/:/ or die "$data ?";
+    my $dakls = cmdoutput
+       access_cfg('ssh'), $`,
+       "set -e; cd $';".
+       " if test -h $isuite; then readlink $isuite; exit 0; fi;".
+       " if test -d $isuite; then echo $isuite; exit 0; fi;".
+       " exit 1";
+    die unless $dakls =~ m/^\w/;
+    return $dakls;
+}
+
+sub madison_parse ($) {
+    my ($rmad) = @_;
+    if (!length $rmad) {
+       return ();
+    }
+    $rmad =~ m{^ \s*( [^ \t|]+ )\s* \|
                  \s*( [^ \t|]+ )\s* \|
-                 \s*( [^ \t|]+ )\s* /x or die "$rmad $?";
+                 \s*( [^ \t|/]+ )(?:/([^ \t|/]+))? \s* \|
+                 \s*( [^ \t|]+ )\s* }x or die "$rmad $?";
     $1 eq $package or die "$rmad $package ?";
     my $vsn = $2;
-    if ($suite ne $3) {
-       # madison canonicalises for us
-       print "canonical suite name for $suite is $3\n";
-       $suite = $3;
+    my $newsuite = $3;
+    my $component;
+    if (defined $4) {
+       $component = $4;
+    } else {
+       $component = access_cfg('archive-query-default-component');
     }
-    $4 eq 'source' or die "$rmad ?";
-    return $vsn;
+    $5 eq 'source' or die "$rmad ?";
+    my $prefix = substr($package, 0, $package =~ m/^l/ ? 4 : 1);
+    my $subpath = "/pool/$component/$prefix/$package/${package}_$vsn.dsc";
+    return ($vsn,$subpath,$newsuite);
+}
+
+sub canonicalise_suite_madison ($$) {
+    my @r = archive_query_madison($_[0],$_[1]);
+    @r or die;
+    return $r[2];
 }
 
 sub canonicalise_suite () {
-    askmadison();
+    $csuite = archive_query('canonicalise_suite');
+    if ($isuite ne $csuite) {
+       # madison canonicalises for us
+       print "canonical suite name for $isuite is $csuite\n";
+    }
 }
 
 sub get_archive_dsc () {
-    my $vsn = askmadison();
-    # fixme madison does not show us the component
-    my $prefix = substr($package, 0, $package =~ m/^l/ ? 4 : 1);
-    $dscurl = "$mirror/pool/main/$prefix/$package/${package}_$vsn.dsc";
+    my ($vsn,$subpath) = archive_query('archive_query');
+    canonicalise_suite();
+    if (!defined $vsn) { $dsc=undef; return undef; }
+    $dscurl = access_cfg('mirror').$subpath;
     $dscdata = url_get($dscurl);
     my $dscfh = new IO::File \$dscdata, '<' or die $!;
-    print DEBUG Dumper($dscdata);
+    print DEBUG Dumper($dscdata) if $debug>1;
     $dsc = Dpkg::Control::Hash->new(allow_pgp=>1);
     $dsc->parse($dscfh, 'dsc') or die "parsing of $dscurl failed\n";
-    print DEBUG Dumper($dsc);
+    print DEBUG Dumper($dsc) if $debug>1;
     my $fmt = $dsc->{Format};
     die "unsupported format $fmt, sorry\n" unless $format_ok{$fmt};
 }
 
 sub check_for_git () {
     # returns 0 or 1
-    my $cmd= 
-       "ssh $alioth_sshtestbodge->[0] '".
-       " set -e; cd $alioth_sshtestbodge->[1];".
-       " if test -d $package.git; then echo 1; else echo 0; fi".
-       "'";
-    print DEBUG "$cmd\n";
-    open P, "$cmd |" or die $!;
-    $!=0; $?=0;
-    my $r = <P>; close P;
-    print DEBUG ">$r<\n";
-    die "$r $! $?" unless $r =~ m/^[01]$/;
-    return $r+0;
+    my $how = access_cfg('git-check');
+    if ($how eq 'ssh-cmd') {
+       my $r= cmdoutput
+           (access_cfg('ssh'),access_gituserhost(),
+            " set -e; cd ".access_cfg('git-path').";".
+            " if test -d $package.git; then echo 1; else echo 0; fi");
+       die "$r $! $?" unless $r =~ m/^[01]$/;
+       return $r+0;
+    } else {
+       die "unknown git-check $how ?";
+    }
+}
+
+sub create_remote_git_repo () {
+    my $how = access_cfg('git-create');
+    if ($how eq 'ssh-cmd') {
+       runcmd_ordryrun
+           (access_cfg('ssh'),access_gituserhost(),
+            "set -e; cd ".access_cfg('git-path').";".
+            " mkdir -p $package.git;".
+            " cd $package.git;".
+            " if ! test -d objects; then git init --bare; fi");
+    } else {
+       die "unknown git-create $how ?";
+    }
 }
 
 our ($dsc_hash,$upload_hash);
@@ -229,7 +385,7 @@ sub mktree_in_ud_from_only_subdir () {
     symlink '../../../../objects','.git/objects' or die $!;
     runcmd @git, qw(add -Af);
     my $tree = cmdoutput @git, qw(write-tree);
-    chomp $tree; $tree =~ m/^\w+$/ or die "$tree ?";
+    $tree =~ m/^\w+$/ or die "$tree ?";
     return ($tree,$dir);
 }
 
@@ -245,6 +401,11 @@ sub is_orig_file ($) {
     m/\.orig(?:-\w+)?\.tar\.\w+$/;
 }
 
+sub make_commit ($) {
+    my ($file) = @_;
+    return cmdoutput @git, qw(hash-object -w -t commit), $file;
+}
+
 sub generate_commit_from_dsc () {
     prep_ud();
     chdir $ud or die $!;
@@ -271,48 +432,57 @@ sub generate_commit_from_dsc () {
     my $authline = "$author $date";
     $authline =~ m/^[^<>]+ \<\S+\> \d+ [-+]\d+$/ or die $authline;
     open C, ">../commit.tmp" or die $!;
-    print C "tree $tree\n" or die $!;
-    print C "parent $upload_hash\n" or die $! if $upload_hash;
     print C <<END or die $!;
+tree $tree
 author $authline
 committer $authline
 
 $clogp->{Changes}
 
-# imported by dgit from the archive
+# imported from the archive
 END
     close C or die $!;
-    my $commithash = cmdoutput @git, qw(hash-object -w -t commit ../commit.tmp);
+    my $outputhash = make_commit qw(../commit.tmp);
     print "synthesised git commit from .dsc $clogp->{Version}\n";
-    chdir '../../../..' or die $!;
-    cmdoutput @git, qw(update-ref -m),"dgit synthesise $clogp->{Version}",
-              'DGIT_ARCHIVE', $commithash;
-    cmdoutput @git, qw(log -n2), $commithash;
-    # ... gives git a chance to complain if our commit is malformed
-    my $outputhash = $commithash;
     if ($upload_hash) {
-       chdir "$ud/$dir" or die $!;
        runcmd @git, qw(reset --hard), $upload_hash;
        runcmd qw(sh -ec), 'dpkg-parsechangelog >>../changelogold.tmp';
        my $oldclogp = Dpkg::Control::Hash->new();
-       $oldclogp->parse('../changelogold.tmp','previous changelog') or die;
+       $oldclogp->load('../changelogold.tmp','previous changelog') or die;
        my $vcmp =
            version_compare_string($oldclogp->{Version}, $clogp->{Version});
        if ($vcmp < 0) {
            # git upload/ is earlier vsn than archive, use archive
-       } elsif ($vcmp >= 0) {
+           open C, ">../commit2.tmp" or die $!;
+           print C <<END or die $!;
+tree $tree
+parent $upload_hash
+parent $outputhash
+author $authline
+committer $authline
+
+Record $package ($clogp->{Version}) in archive suite $csuite
+END
+            $outputhash = make_commit qw(../commit2.tmp);
+       } elsif ($vcmp > 0) {
            print STDERR <<END or die $!;
 Version actually in archive:    $clogp->{Version} (older)
 Last allegedly pushed/uploaded: $oldclogp->{Version} (newer or same)
 Perhaps the upload is stuck in incoming.  Using the version from git.
 END
-       } else {
-           die "version in archive is same as version in git".
-               " to-be-uploaded (upload/) branch but archive".
-               " version hash no commit hash?!\n";
+            $outputhash = $upload_hash;
+       } elsif ($outputhash ne $upload_hash) {
+           die "version in archive ($clogp->{Version})".
+               " is same as version in git".
+               " to-be-uploaded (upload/) branch ($oldclogp->{Version})".
+               " but archive version hash no commit hash?!\n";
         }
-       chdir '../../../..' or die $!;
     }
+    chdir '../../../..' or die $!;
+    runcmd @git, qw(update-ref -m),"dgit fetch import $clogp->{Version}",
+            'DGIT_ARCHIVE', $outputhash;
+    cmdoutput @git, qw(log -n2), $outputhash;
+    # ... gives git a chance to complain if our commit is malformed
     rmtree($ud);
     return $outputhash;
 }
@@ -341,18 +511,19 @@ sub rev_parse ($) {
 
 sub is_fast_fwd ($$) {
     my ($ancestor,$child) = @_;
-    my $mb = cmdoutput @git, qw(merge-base), $dsc_hash, $upload_hash;
+    my $mb = cmdoutput @git, qw(merge-base), $ancestor, $child;
     return rev_parse($mb) eq rev_parse($ancestor);
 }
 
 sub git_fetch_us () {
-    runcmd_ordryrun @git, qw(fetch),$remotename,fetchspec();
+    die "cannot dry run with fetch" if $dryrun;
+    runcmd @git, qw(fetch),access_giturl(),fetchspec();
 }
 
 sub fetch_from_archive () {
     # ensures that lrref() is what is actually in the archive,
     #  one way or another
-    get_archive_dsc();
+    get_archive_dsc() or return 0;
     $dsc_hash = $dsc->{$ourdscfield};
     if (defined $dsc_hash) {
        $dsc_hash =~ m/\w+/ or die "$dsc_hash $?";
@@ -362,12 +533,17 @@ sub fetch_from_archive () {
        print "last upload to archive has NO git hash\n";
     }
 
-    $!=0; $upload_hash =
-       cmdoutput_errok @git, qw(show-ref --heads), lrref();
-    die $! if $!;
-    die $? unless ($?==0 && chomp $upload_hash) 
-       or ($?==256 && !length $upload_hash);
-    $upload_hash ||= '';
+    my $lrref_fn = ".git/".lrref();
+    if (open H, $lrref_fn) {
+       $upload_hash = <H>;
+       chomp $upload_hash;
+       die "$lrref_fn $upload_hash ?" unless $upload_hash =~ m/^\w+$/;
+    } elsif ($! == &ENOENT) {
+       $upload_hash = '';
+    } else {
+       die "$lrref_fn $!";
+    }
+    print DEBUG "previous reference hash $upload_hash\n";
     my $hash;
     if (defined $dsc_hash) {
        die "missing git history even though dsc has hash"
@@ -377,10 +553,11 @@ sub fetch_from_archive () {
     } else {
        $hash = generate_commit_from_dsc();
     }
+    print DEBUG "current hash $hash\n";
     if ($upload_hash) {
        die "not fast forward on last upload branch!".
            " (archive's version left in DGIT_ARCHIVE)"
-           unless is_fast_fwd($dsc_hash, $upload_hash);
+           unless is_fast_fwd($upload_hash, $hash);
     }
     if ($upload_hash ne $hash) {
        my @upd_cmd = (@git, qw(update-ref -m), 'dgit fetch', lrref(), $hash);
@@ -390,10 +567,12 @@ sub fetch_from_archive () {
            dryrun_report @upd_cmd;
        }
     }
+    return 1;
 }
 
 sub clone ($) {
     my ($dstdir) = @_;
+    canonicalise_suite();
     die "dry run makes no sense with clone" if $dryrun;
     mkdir $dstdir or die "$dstdir $!";
     chdir "$dstdir" or die "$dstdir $!";
@@ -402,7 +581,7 @@ sub clone ($) {
     open H, "> .git/HEAD" or die $!;
     print H "ref: ".lref()."\n" or die $!;
     close H or die $!;
-    runcmd @git, qw(remote add), 'origin', "$alioth_git/$package.git";
+    runcmd @git, qw(remote add), 'origin', access_giturl();
     if (check_for_git()) {
        print "fetching existing git history\n";
        git_fetch_us();
@@ -410,31 +589,63 @@ sub clone ($) {
     } else {
        print "starting new git history\n";
     }
-    fetch_from_archive();
+    fetch_from_archive() or die;
     runcmd @git, qw(reset --hard), lrref();
-    print "ready for work in $dstdir\n";
+    printdone "ready for work in $dstdir";
 }
 
 sub fetch () {
     if (check_for_git()) {
        git_fetch_us();
     }
-    fetch_from_archive();
+    fetch_from_archive() or die;
+    printdone "fetched into ".lrref();
 }
 
 sub pull () {
     fetch();
-    runcmd_ordryrun @git, qw(merge -m),"Merge from $suite [dgit]",
+    runcmd_ordryrun @git, qw(merge -m),"Merge from $csuite [dgit]",
         lrref();
+    printdone "fetched to ".lrref()." and merged into HEAD";
+}
+
+sub check_not_dirty () {
+    runcmd @git, qw(diff --quiet);
+}
+
+sub commit_quilty_patch ($) {
+    my ($vsn) = @_;
+    my $output = cmdoutput @git, qw(status --porcelain);
+    my %fixups = map {$_=>1}
+        (".pc/debian-changes-$vsn/","debian/patches/debian-changes-$vsn");
+    my @files;
+    foreach my $l (split /\n/, $output) {
+       next unless $l =~ s/^\?\? //;
+       next unless $fixups{$l};
+       push @files, $l;
+    }
+    print DEBUG "checking for quilty\n", Dumper(\@files);
+    if (@files == 2) {
+       my $m = "Commit Debian 3.0 (quilt) metadata";
+       print "$m\n";
+       runcmd_ordryrun @git, qw(add), @files;
+       runcmd_ordryrun @git, qw(commit -m), $m;
+    }
 }
 
 sub dopush () {
-    runcmd @git, qw(diff --quiet HEAD);
+    print DEBUG "actually entering push\n";
     my $clogp = parsechangelog();
     $package = $clogp->{Source};
     my $dscfn = "${package}_$clogp->{Version}.dsc";
     stat "../$dscfn" or die "$dscfn $!";
     $dsc = parsecontrol("../$dscfn");
+    print DEBUG "format $dsc->{Format}\n";
+    if ($dsc->{Format} eq '3.0 (quilt)') {
+       print "Format \`$dsc->{Format}', urgh\n";
+       commit_quilty_patch($dsc->{Version});
+    }
+    check_not_dirty();
     prep_ud();
     chdir $ud or die $!;
     print "checking that $dscfn corresponds to HEAD\n";
@@ -463,16 +674,12 @@ sub dopush () {
     }
     my $tag = debiantag($dsc->{Version});
     if (!check_for_git()) {
-       runcmd_ordryrun qw(ssh),$alioth_sshtestbodge->[0],
-       "set -e; cd $alioth_sshtestbodge->[1];".
-           " mkdir -p $package.git;".
-           " cd $package.git;".
-           " if ! test -d objects; then git init --bare; fi";
+       create_remote_git_repo();
     }
-    runcmd_ordryrun @git, qw(push),$remotename,"HEAD:".rrref();
+    runcmd_ordryrun @git, qw(push),access_giturl(),"HEAD:".rrref();
     if ($sign) {
        my @tag_cmd = (@git, qw(tag -s -m),
-                      "Release $dsc->{Version} for $suite [dgit]");
+                      "Release $dsc->{Version} for $csuite [dgit]");
        push @tag_cmd, qw(-u),$keyid if defined $keyid;
        push @tag_cmd, $tag;
        runcmd_ordryrun @tag_cmd;
@@ -481,20 +688,25 @@ sub dopush () {
        push @debsign_cmd, $changesfile;
        runcmd_ordryrun @debsign_cmd;
     }
-    runcmd_ordryrun @git, qw(push),$remotename,"refs/tags/$tag";
-    runcmd_ordryrun @dput, $changesfile;
+    runcmd_ordryrun @git, qw(push),access_giturl(),"refs/tags/$tag";
+    my $host = access_cfg('upload-host');
+    my @hostarg = defined($host) ? ($host,) : ();
+    runcmd_ordryrun @dput, @hostarg, $changesfile;
+    printdone "pushed and uploaded $dsc->{Version}";
 }
 
 sub cmd_clone {
+    parseopts();
     my $dstdir;
+    die if defined $package;
     if (@ARGV==1) {
        ($package) = @ARGV;
     } elsif (@ARGV==2 && $ARGV[1] =~ m#^\w#) {
-       ($package,$suite) = @ARGV;
+       ($package,$isuite) = @ARGV;
     } elsif (@ARGV==2 && $ARGV[1] =~ m#^[./]#) {
        ($package,$dstdir) = @ARGV;
     } elsif (@ARGV==3) {
-       ($package,$suite,$dstdir) = @ARGV;
+       ($package,$isuite,$dstdir) = @ARGV;
     } else {
        die;
     }
@@ -504,7 +716,6 @@ sub cmd_clone {
 
 sub branchsuite () {
     my $branch = cmdoutput_errok @git, qw(symbolic-ref HEAD);
-    chomp $branch;
     if ($branch =~ m#$lbranch_re#o) {
        return $1;
     } else {
@@ -513,15 +724,20 @@ sub branchsuite () {
 }
 
 sub fetchpullargs () {
-    my $clogp = parsechangelog();
-    $package = $clogp->{Source};
+    if (!defined $package) {
+       my $sourcep = parsecontrol('debian/control');
+       $package = $sourcep->{Source};
+    }
     if (@ARGV==0) {
-       $suite = branchsuite();
-       $suite ||= $clogp->{Distribution};
+#      $isuite = branchsuite();  # this doesn't work because dak hates canons
+       if (!$isuite) {
+           my $clogp = parsechangelog();
+           $isuite = $clogp->{Distribution};
+       }
        canonicalise_suite();
-       print "fetching from suite $suite\n";
+       print "fetching from suite $csuite\n";
     } elsif (@ARGV==1) {
-       ($suite) = @ARGV;
+       ($isuite) = @ARGV;
        canonicalise_suite();
     } else {
        die;
@@ -529,36 +745,60 @@ sub fetchpullargs () {
 }
 
 sub cmd_fetch {
+    parseopts();
     fetchpullargs();
     fetch();
 }
 
 sub cmd_pull {
+    parseopts();
     fetchpullargs();
     pull();
 }
 
 sub cmd_push {
+    parseopts();
+    die if defined $package;
+    runcmd @git, qw(diff --quiet HEAD);
     my $clogp = parsechangelog();
     $package = $clogp->{Source};
     if (@ARGV==0) {
-       $suite = $clogp->{Distribution};
-       canonicalise_suite();
+       $isuite = $clogp->{Distribution};
+       if ($new_package) {
+           local ($package) = $existing_package; # this is a hack
+           canonicalise_suite();
+       }
     } else {
        die;
     }
+    if (fetch_from_archive()) {
+       is_fast_fwd(lrref(), 'HEAD') or die;
+    } else {
+       die unless $new_package;
+    }
     dopush();
 }
 
 sub cmd_build {
+    # we pass further options and args to git-buildpackage
+    die if defined $package;
     my $clogp = parsechangelog();
-    $suite = $clogp->{Distribution};
+    $isuite = $clogp->{Distribution};
     $package = $clogp->{Source};
-    canonicalise_suite();
-    runcmd_ordryrun
-       qw(git-buildpackage -us -uc --git-no-sign-tags),
-            "--git-debian-branch=".lbranch(),
-            @ARGV;
+    my @cmd =
+       (qw(git-buildpackage -us -uc --git-no-sign-tags),
+        '--git-builder=dpkg-buildpackage -i\.git/ -I.git');
+    unless (grep { m/^--git-debian-branch/ } @ARGV) {
+       canonicalise_suite();
+       push @cmd, "--git-debian-branch=".lbranch();
+    }
+    runcmd_ordryrun @cmd, @ARGV;
+}
+
+sub cmd_quilt_fixup {
+    die if @ARGV;
+    my $clogp = parsechangelog();
+    commit_quilty_patch($clogp->{Version});
 }
 
 sub parseopts () {
@@ -572,10 +812,14 @@ sub parseopts () {
                $dryrun=1;
            } elsif (m/^--no-sign$/) {
                $sign=0;
+           } elsif (m/^--new$/) {
+               $new_package=1;
            } elsif (m/^--(\w+)=(.*)/s && ($om = $opts_opt_map{$1})) {
                $om->[0] = $2;
            } elsif (m/^--(\w+):(.*)/s && ($om = $opts_opt_map{$1})) {
                push @$om, $2;
+           } elsif (m/^--existing-package=(.*)/s) {
+               $existing_package = $1;
            } else {
                die "$_ ?";
            }
@@ -585,8 +829,11 @@ sub parseopts () {
                    $dryrun=1;
                } elsif (s/^-D/-/) {
                    open DEBUG, ">&STDERR" or die $!;
+                   $debug++;
+               } elsif (s/^-N/-/) {
+                   $new_package=1;
                } elsif (s/^-c(.*=.*)//s) {
-                   push @git, $1;
+                   push @git, '-c', $1;
                } elsif (s/^-C(.*)//s) {
                    $changesfile = $1;
                } elsif (s/^-k(.*)//s) {
@@ -600,8 +847,8 @@ sub parseopts () {
 }
 
 parseopts();
+print STDERR "DRY RUN ONLY\n" if $dryrun;
 die unless @ARGV;
 my $cmd = shift @ARGV;
-parseopts();
-
+$cmd =~ y/-/_/;
 { no strict qw(refs); &{"cmd_$cmd"}(); }